
num_of_obv=10^4; %number of samples to be drawn
n=5; %dimension of the random vector 

%Zipf distribution
s=1.2; %zipf distribution parameter
[shuffled_obs,unique_symb]=generate_obv(s,n,num_of_obv); % This routine generates observations from a given distribution
                                                         % and also returns the number of unique symbols

B=1;                                                   %number of blocks we are intersted in 
                                                       %(for this example, a single block of size n)
[emp_p]=extract_prob(shuffled_obs,B);    %This routine takes observations of a given dimension, 
                                                       %splits it into B blocks and return a matrix with the 
                                                       %empirical distribution of each block

%joint entropy
emp_ent=-sum(emp_p(emp_p>0).*log2(emp_p(emp_p>0)));

%marginal entropies
est_margs=mean(shuffled_obs);
est_margs=est_margs(est_margs>0);
marginals_before=sum(-est_margs.*log2(est_margs)-(1-est_margs).*log2(1-est_margs));

%apply BICA
min_k=4;  %minimal number of k (pieces of the piecewise linear function) to be eaxamined  
max_k=10; %maximal number of k to be eaxamined
[opt_p,opt_perm,est_vals,marginals_after]=BICA_function(emp_p,min_k,max_k);  %This BICA function applies the BICA on 
                                                                     %on a range of k values and returns the best result.

fprintf('empirical joint entropy = %f \n',emp_ent);
fprintf('empirical sum of marginal entropy with no permutations= %f \n',marginals_before);
fprintf('empirical sum of marginal entropy after permutation= %f \n',marginals_after);
                                                                     